// s21.h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define PRIVATE		static

#define LDA 1		// op code number
#define LDD 2
#define STA 3
#define STD 4
//#define MVI 5
//#define JMP 6
#define JAL 7
#define JT 8
#define JF 9
#define ADDI 10
#define SUBI 11
#define MULI 12
#define DIVI 13
#define ANDI 14
#define ORI 15
#define XORI 16
#define EQI 17
#define NEI 18
#define LTI 19
#define LEI 20
#define GTI 21
#define GEI 22
#define SHLI 23
#define SHRI 24
#define XOP 31

#define ADD 0		// xop
#define SUB 1
#define MUL 2
#define DIV 3
#define AND 4
#define OR 5
#define XOR 6
#define EQ 7
#define NE 8
#define LT 9
#define LE 10
#define GT 11
#define GE 12
#define SHL 13
#define SHR 14
#define MV 15
#define LDX 16
#define STX 17
#define RET 18
#define TRAP 19
#define PUSH 20
#define POP 21
// movi 22
#define RETI 23 // 24


// as23 not yet emit these codes

#define NOT 22
#define INTR 24 // 23

#define SAVR 25
#define RESR 26
#define SAVT 27
#define REST 28

#define MAXMEM		5000		// memory max
#define NIL			-1
#define DEL			100			// interrupt interval (inst)
#define INTVEC		1000		// int vec location

#define RETV		28			// return value register
#define SPTR		29			// stack pointer

#define PTXTX		150			// (x,y) graphic text box
#define PTXTY		20

#define eqs(a,b)  (strcmp(a,b)==0)

#define INT long

// IR bits
INT IRop(void); 	// bit 31..27
INT IRr1(void); 	// bit 26..22
INT IRads(void);	// bit 21..0
INT IRr2(void); 	// bit 21..17
INT IRr3(void); 	// bit 16..12
INT IRxop(void);	// bit 11..0
INT IRdisp(void);	// bit 16..0

//extern INT clock, ninst;

void error(char *s);
void interp(void);
void loadprogram(char *s);
//void countclock();
void show(void);
void trap(INT reg, INT num);
INT signx2( INT d );
//void dumpreg(void);

//void gensin(void);
//void showsin(void);
//void gendig(void);
//void showdig(void);
void init_io(void);
INT readsinport(void);
INT readdigport(void);
INT myrandom(void);
void simdevices(void);

// graphic
void textxy(INT x, INT y, char *s);
void dotxy(INT x, INT y);
void init_graph(void);
void close_graph(void);


